Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/include/Parameters.h	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/include/Parameters.h	(revision 138)
@@ -34,5 +34,5 @@
   public : uint32_t              * _nb_inst_reexecute                    ;//[nb_ooo_engine]
   public : uint32_t              * _nb_inst_issue_queue                  ;//[nb_ooo_engine]
-  public : uint32_t              * _nb_inst_issue_slot                   ;//[nb_ooo_engine]
+//public : uint32_t              * _nb_inst_issue_slot                   ;//[nb_ooo_engine]
   public : uint32_t             ** _nb_inst_execute                      ;//[nb_ooo_engine][ooo_engine_nb_execute_loop]
   public : bool                  * _issue_queue_in_order                 ;//[nb_ooo_engine]
@@ -52,9 +52,12 @@
   public : Tpriority_t             _dispatch_priority                    ;
   public : Tload_balancing_t       _dispatch_load_balancing              ;
-  public : bool               **** _table_dispatch                       ;//[nb_ooo_engine][nb_inst_issue_slot][execute_loop][nb_read_unit]
+//public : bool               **** _table_dispatch                       ;//[nb_ooo_engine][nb_inst_issue_slot][execute_loop][nb_read_unit]
   public : bool                *** _table_issue_type                     ;//                                   [execute_loop][nb_read_unit][nb_type]
+  public : bool                *** _table_issue_thread                   ;//                                   [execute_loop][nb_read_unit][nb_thread]
+
   public : uint32_t             ** _translate_ooo_engine_num_front_end   ;//[nb_ooo_engine][ooo_engine_nb_front_end]
   public : uint32_t             ** _translate_ooo_engine_num_execute_loop;//[nb_ooo_engine][ooo_engine_nb_execute_loop]
   public : uint32_t             ** _translate_execute_loop_num_ooo_engine;//[nb_execute_loop][execute_loop_nb_ooo_engine]
+  public : uint32_t            *** _translate_num_context_to_num_thread  ;//[nb_ooo_engine][ooo_engine_nb_front_end][nb_context]
 
   public : uint32_t              * _link_ooo_engine_with_front_end                          ;//[nb_front_end]
@@ -65,5 +68,5 @@
 
 //public : uint32_t             ** _execute_loop_nb_inst_insert                             ;//[nb_execute_loop][execute_loop_nb_ooo_engine]
-  public : uint32_t             ** _execute_loop_nb_inst_issue_slot                         ;//[nb_execute_loop][execute_loop_nb_ooo_engine]
+//public : uint32_t             ** _execute_loop_nb_inst_issue_slot                         ;//[nb_execute_loop][execute_loop_nb_ooo_engine]
 //public : uint32_t              * _link_execute_loop_with_ooo_engine                       ;//[nb_ooo_engine]
 
@@ -75,5 +78,5 @@
 //public : uint32_t                _max_nb_inst_insert                    ;
   public : uint32_t                _max_nb_inst_issue_queue               ;
-  public : uint32_t                _max_nb_inst_issue_slot                ;
+//public : uint32_t                _max_nb_inst_issue_slot                ;
   public : uint32_t                _max_nb_read_unit                      ;
 
@@ -90,8 +93,8 @@
    uint32_t              * front_end_nb_inst_branch_complete    ,//[nb_front_end]
    uint32_t              * ooo_engine_nb_inst_branch_complete   ,//[nb_ooo_engine]
-//    uint32_t              * nb_inst_insert                       ,//[nb_ooo_engine]
+// uint32_t              * nb_inst_insert                       ,//[nb_ooo_engine]
    uint32_t              * nb_inst_reexecute                    ,//[nb_ooo_engine]
    uint32_t              * nb_inst_issue_queue                  ,//[nb_ooo_engine]
-   uint32_t              * nb_inst_issue_slot                   ,//[nb_ooo_engine]
+// uint32_t              * nb_inst_issue_slot                   ,//[nb_ooo_engine]
    uint32_t             ** nb_inst_execute                      ,//[nb_ooo_engine][ooo_engine_nb_execute_loop]
    bool                  * issue_queue_in_order                 ,//[nb_ooo_engine]
@@ -108,10 +111,12 @@
    Tpriority_t             dispatch_priority                    ,
    Tload_balancing_t       dispatch_load_balancing              ,
-   bool               **** table_dispatch                       ,//[nb_ooo_engine][nb_inst_issue_slot][execute_loop][nb_read_unit]
+// bool               **** table_dispatch                       ,//[nb_ooo_engine][nb_inst_issue_slot][execute_loop][nb_read_unit]
    bool                *** table_issue_type                     ,//                                   [execute_loop][nb_read_unit][nb_type]
-// bool                *** table_issue_thread                   ,//                                   [execute_loop][nb_read_unit][nb_thread]
+   bool                *** table_issue_thread                   ,//                                   [execute_loop][nb_read_unit][nb_thread]
    uint32_t             ** translate_ooo_engine_num_front_end   ,//[nb_ooo_engine][ooo_engine_nb_front_end]
    uint32_t             ** translate_ooo_engine_num_execute_loop,//[nb_ooo_engine][ooo_engine_nb_execute_loop]
    uint32_t             ** translate_execute_loop_num_ooo_engine,//[nb_execute_loop][execute_loop_nb_ooo_engine]
+   uint32_t            *** translate_num_context_to_num_thread  ,//[nb_ooo_engine][ooo_engine_nb_front_end][nb_context]
+
    bool                    is_toplevel=false);
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_issue.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_issue.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_issue.cpp	(revision 138)
@@ -16,28 +16,28 @@
 
   /*
-      OOO        SLOT     Execute Loop                                  
-    ---+                      +-----
-       |  +-----+     +-----+ |     
-      -+->|     |     |     |-+->   
-       |  |     |-()->|     | |     
-      -+->| _ _ |     |     |-+->   
-       |  | _X_ |-()->|     | |     
-      -+->|     |     |     | +-----
-       |  |     |-()->|     |       
-      -+->|     |     |     | +-----
-       |  +-----+     |     | |     
-    ---+  crossbar    | _ _ |-+->   
-                      | _X_ | |     
-    ---+              |     |-+->   
-       |  +-----+     |     | |     
-      -+->|     |     |     | +-----
-       |  |     |-()->|     |       
-      -+->| _ _ |     |     | +-----
-       |  | _X_ |-()->|     | |     
-      -+->|     |     |     |-+->   
-       |  |     |-()->|     | |     
-      -+->|     |     |     |-+->   
-       |  +-----+     +-----+ |     
-    ---+  crossbar   dispatch +-----
+      OOO     Execute Loop                                  
+    ---+          +-----
+       |  +-----+ |     
+      -+->|     |-+->   
+       |  |     | |     
+      -+->|     |-+->   
+       |  |     | |     
+      -+->|     | +-----
+       |  |     |       
+      -+->|     | +-----
+       |  |     | |     
+    ---+  | _ _ |-+->   
+          | _X_ | |     
+    ---+  |     |-+->   
+       |  |     | |     
+      -+->|     | +-----
+       |  |     |       
+      -+->|     | +-----
+       |  |     | |     
+      -+->|     |-+->   
+       |  |     | |     
+      -+->|     |-+->   
+       |  +-----+ |     
+    ---+ dispatch +-----
   */
 
@@ -75,11 +75,6 @@
       {
     Tcontrol_t READ_UNIT_ENABLE       [_param->_nb_execute_loop][_param->_max_nb_read_unit];
-    Tcontrol_t SLOT_ENABLE            [_param->_nb_ooo_engine  ][_param->_max_nb_inst_issue_slot];
     
     // Init -> all at 0
-    for (uint32_t i=0; i<_param->_nb_ooo_engine; ++i)
-      for (uint32_t j=0; j<_param->_nb_inst_issue_slot[i]; ++j)
-        SLOT_ENABLE [i][j] = 1;         
-
     for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
       for (uint32_t j=0; j<_param->_nb_read_unit[i]; ++j)
@@ -90,39 +85,4 @@
         }
 
-//     std::list<num_read_unit_t> SLOT_TYPE [_param->_nb_ooo_engine][_param->_max_nb_inst_issue_slot][_param->_nb_type];
-
-//     // for each read_unit
-//     for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
-//       for (uint32_t j=0; j<_param->_nb_read_unit[i]; ++j)
-//         // test if this read_unit can receive an instruction
-//         if (PORT_READ(in_ISSUE_EXECUTE_LOOP_ACK [i][j]) == 1)
-//           for (uint32_t x=0; x<_nb_ooo_engine; ++x)
-//             for (uint32_t y=0; y<_nb_inst_issue_slot[y]; ++y)
-//               // test if can dispatch
-//               if (_param->_table_dispatch [x][y][i][j])
-//                 for (uint32_t k=0;k<_param->_nb_type; ++k)
-//                   // Can receive this type
-//                   if (_param->_table_dispatch [i][j][k])
-//                     SLOT_TYPE[x][y][k].push_back(num_read_unit_t(i,j));
-
-//     // Select an issue_slot of an ooo_engine
-//     std::list<generic::priority::select_t> * select_ooo_engine = _priority_ooo_engine->select();
-//     for (std::list<generic::priority::select_t>::iterator it_ooo_engine=select_ooo_engine->begin();
-//          it_ooo_engine!=select_ooo_engine->end();
-//          ++it_ooo_engine)
-//       { 
-//         // ... get id of the most priotary
-//         const uint32_t num_ooo_engine      = it_ooo_engine->grp;
-//         const uint32_t num_inst_issue_slot = it_ooo_engine->elt;
-
-//         // Test if this ooo_engine is enable (can be desable if issue in_order)
-//         if (OOO_ENGINE_ENABLE[num_ooo_engine])
-//           {
-
-//           }
-//       }
-
-//     for (uint32_t num_ooo_engine=0; num_ooo_engine<_param->_nb_ooo_engine; ++num_ooo_engine)
-
     std::list<generic::priority::select_t> * select_ooo_engine = _priority_ooo_engine->select();
     for (std::list<generic::priority::select_t>::iterator it_ooo_engine=select_ooo_engine->begin();
@@ -130,100 +90,98 @@
          ++it_ooo_engine)
       {
-        uint32_t num_ooo_engine      = it_ooo_engine->grp;
+        // select the most priotary 
+        uint32_t num_ooo_engine = it_ooo_engine->grp;
 
         for (uint32_t num_inst_issue_queue=0; num_inst_issue_queue<_param->_nb_inst_issue_queue[num_ooo_engine]; ++num_inst_issue_queue)
           {
+            // init stop condition
             bool find = false;
             
-            Tcontrol_t val  = PORT_READ(in_ISSUE_OOO_ENGINE_VAL  [num_ooo_engine][num_inst_issue_queue]);
-            Ttype_t    type = PORT_READ(in_ISSUE_OOO_ENGINE_TYPE [num_ooo_engine][num_inst_issue_queue]);
+            // Read request information from issue_queue
+            Tcontrol_t val          = PORT_READ(in_ISSUE_OOO_ENGINE_VAL  [num_ooo_engine][num_inst_issue_queue]);
+            Ttype_t    type         = PORT_READ(in_ISSUE_OOO_ENGINE_TYPE [num_ooo_engine][num_inst_issue_queue]);
+            Tcontext_t context_id   = (_param->_have_port_context_id  )?PORT_READ(in_ISSUE_OOO_ENGINE_CONTEXT_ID   [num_ooo_engine][num_inst_issue_queue]):0;
+            Tcontext_t front_end_id = (_param->_have_port_front_end_id)?PORT_READ(in_ISSUE_OOO_ENGINE_FRONT_END_ID [num_ooo_engine][num_inst_issue_queue]):0;
+            uint32_t   num_thread    = _param->_translate_num_context_to_num_thread[num_ooo_engine][front_end_id][context_id];
             
             log_printf(TRACE,Core_Glue,FUNCTION,"  * num_ooo_engine                : %d",num_ooo_engine      );
             log_printf(TRACE,Core_Glue,FUNCTION,"  * num_inst_issue_queue          : %d",num_inst_issue_queue);
             log_printf(TRACE,Core_Glue,FUNCTION,"    * val                         : %d",val);
-            log_printf(TRACE,Core_Glue,FUNCTION,"    * type                        : %d",type);
-            
+            log_printf(TRACE,Core_Glue,FUNCTION,"    * type                        : %d",type);  
+            log_printf(TRACE,Core_Glue,FUNCTION,"    * context_id                  : %d",context_id);
+            log_printf(TRACE,Core_Glue,FUNCTION,"    * front_end_id                : %d",front_end_id);
+            log_printf(TRACE,Core_Glue,FUNCTION,"    * num_thread                  : %d",num_thread);
+          
             if (val)
-              for (uint32_t num_inst_issue_slot=0; num_inst_issue_slot<_param->_nb_inst_issue_slot[num_ooo_engine]; ++num_inst_issue_slot)
+              // for each execute_loop
+              for (uint32_t num_execute_loop=0; num_execute_loop<_param->_nb_execute_loop; ++num_execute_loop)
                 {
-                  log_printf(TRACE,Core_Glue,FUNCTION,"    * num_inst_issue_slot         : %d",num_inst_issue_slot);
-                  
-                  // scan all read_unit
-                  
-                  if (SLOT_ENABLE [num_ooo_engine][num_inst_issue_slot])
-                    for (uint32_t num_execute_loop=0; num_execute_loop<_param->_nb_execute_loop; ++num_execute_loop)
-                      {
-                        std::list<generic::priority::select_t> * select_read_unit = _priority_read_unit[num_execute_loop]->select();
-                        for (std::list<generic::priority::select_t>::iterator it_read_unit=select_read_unit->begin();
-                             it_read_unit!=select_read_unit->end();
-                             ++it_read_unit)
-                          {
-                            // get the most priotary ...
-                            uint32_t num_read_unit = it_read_unit->grp;
-                            Tcontrol_t ack = READ_UNIT_ENABLE [num_execute_loop][num_read_unit];
-                            
-                            log_printf(TRACE,Core_Glue,FUNCTION,"      * num_execute_loop          : %d",num_execute_loop);
-                            log_printf(TRACE,Core_Glue,FUNCTION,"      * num_read_unit             : %d",num_read_unit   );
-                            log_printf(TRACE,Core_Glue,FUNCTION,"        * read_unit_enable        : %d",ack             );
-                            
-                            // test if :
-                            //  * read_unit can accept an instruction (valid and no previous instruction)
-                            //  * slot can issue an instruction at this read_unit
-                            //  * read_unit can accept this type
-                            if (ack and
-                                _param->_table_dispatch [num_ooo_engine][num_inst_issue_slot][num_execute_loop][num_read_unit] and
-                                _param->_table_issue_type [num_execute_loop][num_read_unit][type])
-                              {
-                                log_printf(TRACE,Core_Glue,FUNCTION,"  * find !!!");
-                                
-                                // find !
-                                // Transaction
-                                READ_UNIT_ENABLE       [num_execute_loop][num_read_unit] = false; // now, this read_unit is busy
-                                ISSUE_EXECUTE_LOOP_VAL [num_execute_loop][num_read_unit] = 1; // = val
-                                ISSUE_OOO_ENGINE_ACK   [num_ooo_engine][num_inst_issue_queue] = 1; // = ack
-                                SLOT_ENABLE            [num_ooo_engine][num_inst_issue_slot]  = false; // now this slot is used
-                                      
-                                if (_param->_have_port_context_id)
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_CONTEXT_ID            [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_CONTEXT_ID            [num_ooo_engine][num_inst_issue_queue]));
-			        if (_param->_have_port_front_end_id)
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_FRONT_END_ID          [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_FRONT_END_ID          [num_ooo_engine][num_inst_issue_queue]));
-			        if (_param->_have_port_ooo_engine_id)
-                                  {
-                                Tcontext_t ooo_engine_id = _param->_translate_num_ooo_engine_to_execute_loop_ooo_engine_id [num_ooo_engine][num_execute_loop];
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_OOO_ENGINE_ID         [num_execute_loop][num_read_unit],ooo_engine_id);
-                                  }
-			        if (_param->_have_port_rob_ptr)
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_PACKET_ID             [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_PACKET_ID             [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_OPERATION             [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_OPERATION             [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_TYPE                  [num_execute_loop][num_read_unit],type);
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_CANCEL                [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_CANCEL                [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_STORE_QUEUE_PTR_WRITE [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_STORE_QUEUE_PTR_WRITE [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_STORE_QUEUE_PTR_READ  [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_STORE_QUEUE_PTR_READ  [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_STORE_QUEUE_EMPTY     [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_STORE_QUEUE_EMPTY     [num_ooo_engine][num_inst_issue_queue]));
-			        if (_param->_have_port_load_queue_ptr)
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_LOAD_QUEUE_PTR_WRITE  [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_LOAD_QUEUE_PTR_WRITE  [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_HAS_IMMEDIAT          [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_HAS_IMMEDIAT          [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_IMMEDIAT              [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_IMMEDIAT              [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_READ_RA               [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_READ_RA               [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RA            [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RA            [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_READ_RB               [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_READ_RB               [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RB            [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RB            [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_READ_RC               [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_READ_RC               [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RC            [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RC            [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_WRITE_RD              [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_WRITE_RD              [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RD            [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RD            [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_WRITE_RE              [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_WRITE_RE              [num_ooo_engine][num_inst_issue_queue]));
-			        PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RE            [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RE            [num_ooo_engine][num_inst_issue_queue]));
-                              
-                                
-                                find = true;
-                                break;
-                              }
-                            //if (find)
-                            //  break;
-                          }
-                        if (find)
+                  // for each read_unit
+                  std::list<generic::priority::select_t> * select_read_unit = _priority_read_unit[num_execute_loop]->select();
+                  for (std::list<generic::priority::select_t>::iterator it_read_unit=select_read_unit->begin();
+                       it_read_unit!=select_read_unit->end();
+                       ++it_read_unit)
+                    {
+                      // get the most priotary ...
+                      uint32_t num_read_unit = it_read_unit->grp;
+                      Tcontrol_t ack = READ_UNIT_ENABLE [num_execute_loop][num_read_unit];
+                      
+                      log_printf(TRACE,Core_Glue,FUNCTION,"      * num_execute_loop          : %d",num_execute_loop);
+                      log_printf(TRACE,Core_Glue,FUNCTION,"      * num_read_unit             : %d",num_read_unit   );
+                      log_printf(TRACE,Core_Glue,FUNCTION,"        * read_unit_enable        : %d",ack             );
+                      
+                      // test if :
+                      //  * read_unit can accept an instruction (valid and no previous instruction)
+                      //  * read_unit can accept this type
+                      if (ack and
+                          _param->_table_issue_type   [num_execute_loop][num_read_unit][type] and
+                          _param->_table_issue_thread [num_execute_loop][num_read_unit][num_thread])
+                        {
+                          log_printf(TRACE,Core_Glue,FUNCTION,"  * find !!!");
+                          
+                          // find !
+                          // Transaction
+                          find = true;
+
+                          READ_UNIT_ENABLE       [num_execute_loop][num_read_unit] = false; // now, this read_unit is busy
+                          ISSUE_EXECUTE_LOOP_VAL [num_execute_loop][num_read_unit] = 1; // = val
+                          ISSUE_OOO_ENGINE_ACK   [num_ooo_engine][num_inst_issue_queue] = 1; // = ack
+                          
+                          if (_param->_have_port_context_id)
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_CONTEXT_ID            [num_execute_loop][num_read_unit],context_id);
+                          if (_param->_have_port_front_end_id)
+			  PORT_WRITE(out_ISSUE_EXECUTE_LOOP_FRONT_END_ID          [num_execute_loop][num_read_unit],front_end_id);
+                          if (_param->_have_port_ooo_engine_id)
+                            {
+                          Tcontext_t ooo_engine_id = _param->_translate_num_ooo_engine_to_execute_loop_ooo_engine_id [num_ooo_engine][num_execute_loop];
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_OOO_ENGINE_ID         [num_execute_loop][num_read_unit],ooo_engine_id);
+                            }
+                          if (_param->_have_port_rob_ptr)
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_PACKET_ID             [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_PACKET_ID             [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_OPERATION             [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_OPERATION             [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_TYPE                  [num_execute_loop][num_read_unit],type);
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_CANCEL                [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_CANCEL                [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_STORE_QUEUE_PTR_WRITE [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_STORE_QUEUE_PTR_WRITE [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_STORE_QUEUE_PTR_READ  [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_STORE_QUEUE_PTR_READ  [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_STORE_QUEUE_EMPTY     [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_STORE_QUEUE_EMPTY     [num_ooo_engine][num_inst_issue_queue]));
+                          if (_param->_have_port_load_queue_ptr)
+			  PORT_WRITE(out_ISSUE_EXECUTE_LOOP_LOAD_QUEUE_PTR_WRITE  [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_LOAD_QUEUE_PTR_WRITE  [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_HAS_IMMEDIAT          [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_HAS_IMMEDIAT          [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_IMMEDIAT              [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_IMMEDIAT              [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_READ_RA               [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_READ_RA               [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RA            [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RA            [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_READ_RB               [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_READ_RB               [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RB            [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RB            [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_READ_RC               [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_READ_RC               [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RC            [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RC            [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_WRITE_RD              [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_WRITE_RD              [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RD            [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RD            [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_WRITE_RE              [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_WRITE_RE              [num_ooo_engine][num_inst_issue_queue]));
+                          PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RE            [num_execute_loop][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RE            [num_ooo_engine][num_inst_issue_queue]));
                           break;
-                      }
+                        }
+                      //if (find)
+                      //  break;
+                    }
                   if (find)
                     break;
@@ -240,5 +198,5 @@
           }
       }
-
+    
       }
 
